#include <iostream>

enum colours { RED, GREEN, BLUE };
enum permissions {
	EXECUTE = 1,
	WRITE = 2,
	READ = 4,
};

enum class beverage { NO_THANKS, TEA, COFFEE };

void print_beverage(beverage b) {
	using enum beverage;  // since C++20
	switch (b) {
	case TEA:
		std::cout << "tea\n";
		break;
	case COFFEE:
		std::cout << "coffee\n";
		break;
	default:;  // silence the unhandled value warning
	}
}

int main() {
	std::cout << sizeof(colours) << ' ' << sizeof(permissions) << '\n';

	int colour = RED;  // OK
	auto rwx = static_cast<permissions>(7);  // OK; 8 would be UB

	std::cout << colour << ' ' << rwx << '\n';

	auto coffee = static_cast<int>(beverage::COFFEE);

	std::cout << coffee << '\n';

	auto choice = beverage::TEA;
	print_beverage(choice);
}
