#include <iostream>
#include <optional>

std::optional<int> safe_div(int p, int q) {
	if (q == 0)
		return {};  // or std::nullopt
	return p / q;
}

void show(int p, int q) {
	auto result = safe_div(p, q);

	if (result) {
		std::cout << "result: " << *result << '\n';
	} else {
		std::cout << "result is nullopt\n";
	}

	std::cout << "value_or(-1): " << result.value_or(-1) << '\n';

	try {
		std::cout << "value(): " << result.value() << '\n';
	} catch (std::bad_optional_access& ex) {
		std::cout << "Exception: " << ex.what() << '\n';
	}
}

int main() {
	show(33, 2);
	std::cout << "---\n";
	show(0, 7);
	std::cout << "---\n";
	show(5, 0);
}
