#include <iostream>
#include <variant>
#include <vector>

int main() {
	std::variant<int, double, std::vector<int>> v = 3.14;

	std::cout << v.index() << '\n';
	std::cout << std::holds_alternative<int>(v) << '\n';

	try {
		std::cout << std::get<1>(v) << '\n';
		std::cout << std::get<double>(v) << '\n';
	} catch (std::bad_variant_access& ex) {
		std::cout << "Exception: " << ex.what() << '\n';
	}

	if (auto* ptr = std::get_if<double>(&v)) {
		std::cout << "got double: " << *ptr << '\n';
	} else {
		std::cout << "not double\n";
	}
}
