#include <iostream>
#include <variant>
#include <vector>

struct pretty_printer {
	void operator()(auto x) const {
		std::cout << x << '\n';
	}
	void operator()(char c) const {
		std::cout << "'" << c << "'\n";
	}
};

struct tell_type {
	void operator()(int) const { std::cout << "int\n"; }
	void operator()(char) const { std::cout << "char\n"; }
	void operator()(double) const { std::cout << "double\n"; }
};

int main() {
	using Var = std::variant<int, char, double>;
	std::vector<Var> vec = { 3, 3.14, 'p' };

	for (auto& v : vec) {
		std::visit([](auto x) {
			std::cout << x << '\n';
		}, v);

		std::visit(tell_type{}, v);
		std::visit(pretty_printer{}, v);

		auto result = std::visit(
			[](auto x) -> Var {
				return x + x;
			}, v);

		std::visit(pretty_printer{}, result);

		auto result2 = std::visit<int>(
			[](auto x) {
				return x + x;
			}, v);

		std::cout << result2 << "\n---\n";
	}
}
